/*
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#include <iostream>
#include <fstream>
#include <math.h>
#define pi 3.14159265358979323846264338

using namespace std;


int i;
double convertrot(double in);

int main()
{
    double rotDouble;
    ifstream fileIn;
    char xPos[50], yPos[50], zPos[50], xSize[50], ySize[50], zSize[50], rot[50];
    long double ldzPos, ldxPos, ldyPos, ldzSize;
    string tester, line, rotString;
    char name[50];
    size_t findPos, findPos2;
    short box=0, pyr=0, tel=0;

    cout<<"Anim8or to BZW converter.\n";
    cout<<"Licensed under GNUv3. (see licents.txt)\n";
    cout<<"Made by EvanEjk.\n";
    cout<<"EvanEjk@gmail.com\n\n";
    cout<<"Proceed? (1=yes 0=no)\n\n";
    short ask;
    cin>>ask;
    if (ask==0)
        {
        cout<<"Close program.\n";
        while(1){}
        }
    fileIn.open("map.an8");
    ofstream fileOut ("map.bzw");
    if (fileIn==0)
        {
        cout << "Error opening file.\n";
        }
    else
        {
        cout << "File loaded.\n";
        }
    fileOut << "#Converted from anim8or file.\n";
    fileOut << "#Converter made by EvanEjk.\n";
    fileOut << "#EvanEjk@gmail.com\n\n";

    while(1) //This while converts cubes.
        {
        tester="  cube {";
        getline (fileIn,line);
        //cout << "Searching: "<<line<<"\n";
        if (line == tester)
            {
                cout << "\n********** Found an object. **********\n";
                //find the name!
                tester="name";
                i=1;
                while(i) //This while finds name line
                    {
                    if (fileIn.eof())
                        {
                        cout << "Error while finding object's name.\n";
                        goto end;
                        }
                    getline(fileIn,line);
                    findPos=line.find(tester);
                    if (findPos!=string::npos)
                        {
                        rot[0]='0';
                        rot[1]='\0';
                        i=0; //To stop loop
                        cout<<"\nFound the object's name line.\n";
                        cout<<""<<line<<"\n";
                        tester="\"";
                        findPos=line.find(tester); //finds first quote mark
                        findPos2=line.find(tester, findPos+1); //finds second quote mark
                        size_t length;
                        length=line.copy(name, (findPos2-findPos-1), findPos+1); //copies the name into name
                        name[length]='\0';
                        cout<<"Name: "<<name<<"\n";

                        box=1; //By default it is a box.
                        tel=0;
                        pyr=0;
                        tester="pyr";
                        if ((line.find(tester))!=string::npos)
                            {
                            cout<<"Object is a pyramid.\n";
                            box=0;
                            tel=0;
                            pyr=1;
                            }
                        tester="tel";
                        if ((line.find(tester))!=string::npos)
                            {
                            cout<<"Object is a teleport.\n";
                            box=0;
                            tel=1;
                            pyr=0;
                            }
                        }
                    }
                tester="origin";
                i=1;
                while(i)
                    {
                    if (fileIn.eof())
                        {
                        cout<<"Error while finding origin.\n";
                        goto end;
                        }
                    getline(fileIn,line);
                    findPos=line.find(tester);
                    if (findPos!=string::npos)
                        {
                        i=0;
                        cout<<"\nFound the origin line.\n";
                        cout<<line<<"\n";
                        size_t length;

                        tester="(";
                        findPos=line.find(tester);
                        //under this looks same for next two cords
                        tester=" ";
                        findPos2=line.find(tester, findPos+1);
                        length=line.copy(xPos, (findPos2-findPos-1), findPos+1);
                        xPos[length]='\0';
                        cout<<"x position: "<<xPos<<"\n";

                        tester=" ";
                        findPos=line.find(tester, findPos2+1);
                        length=line.copy(zPos, (findPos-findPos2-1), findPos2+1);
                        zPos[length]='\0';
                        cout<<"z position: "<<zPos<<"\n";

                        tester=")";
                        findPos2=line.find(tester, findPos+1);
                        length=line.copy(yPos, (findPos2-findPos-1), findPos+1);
                        yPos[length]='\0';
                        cout<<"y position: "<<yPos<<"\n";
                        }
                    }


                tester="orientation";
                rotString="0";
                i=1;
                while(i)
                {
                    if (fileIn.eof())
                        {
                        cout<<"Error: At end of file.";
                        goto end;
                        }
                    getline(fileIn,line);
                    tester="orientation";
                    if ((line.find(tester))!=string::npos)
                        {
                        cout<<"\nFound the orientation line.\n";
                        size_t length;
                        i=0;
                        tester="(";
                        findPos=line.find(tester);
                        tester=" ";
                        findPos2=line.find(tester, findPos+1);//first space
                        findPos=line.find(tester, findPos2+1);//second space
                        findPos2=line.find(tester, findPos+1);//third space
                        tester=")";
                        findPos=line.find(tester, findPos2+1);
                        //findPos2 is at start, findPos is at end
                        length=line.copy(rot, (findPos-findPos2-1), findPos2+1);
                        rot[length]='\0';
                        rotString=rot;
                        cout << "orientation: "<<rotString<<"\n";
                        }

                    tester="scale";
                    findPos=line.find(tester);
                    if ((line.find(tester))!=string::npos)
                        {
                        cout << "\nNo orientation.\n";
                        rotString="0";
                        break;
                        }
                }


                tester="scale";
                i=1;
                while(i)
                    {
                    if (fileIn.eof())
                        {
                        cout<<"Error while finding size.\n";
                        goto end;
                        }
                    findPos=line.find(tester);
                    if (findPos!=string::npos)
                        {
                        i=0;
                        cout<<"\nFound size line.\n";
                        size_t length;
                        cout<<line<<"\n";
                        tester="{ ";
                        findPos=line.find(tester);
                        findPos++;
                        tester=" ";
                        findPos2=line.find(tester, findPos+1);
                        length=line.copy(xSize, (findPos2-findPos-1), findPos+1);
                        xSize[length]='\0';
                        cout<<"x size: "<<xSize<<"\n";

                        tester=" ";
                        findPos=line.find(tester, findPos2+1);
                        length=line.copy(zSize, (findPos-findPos2-1), findPos2+1);
                        zSize[length]='\0';
                        cout<<"z size: "<<zSize<<"\n";

                        tester=" }";
                        findPos2=line.find(tester, findPos+1);
                        length=line.copy(ySize, (findPos2-findPos-1), findPos+1);
                        ySize[length]='\0';
                        cout<<"y position: "<<ySize<<"\n";
                        }
                    getline(fileIn,line);
                    }
                ldzSize=strtod(zSize,0);
                ldzPos=strtod(zPos,0);
                ldxPos=strtod(xPos,0);
                ldyPos=strtod(yPos,0);
                cout<<"\n** Fixing bzflag's stupid object size to cordnance ratio. **\n";
                ldzPos+=ldzPos;
                ldxPos+=ldxPos;
                ldyPos+=ldyPos;
                cout<<"\n** Fixing bzflag's stupid height ratio. **\n";
                ldzSize+=ldzSize;
                cout<<"\n** Fixing bzflag's stupid object hight/position thing... **\n";
                ldzPos=ldzPos-(.5*ldzSize);
                cout<<"\n** Fixing bzflag's stupid Y pos/neg flip thing... **\n";
                ldyPos=ldyPos*-1;

                if (box==1)
                    {
                    fileOut<<"box\n";
                    }
                if (tel==1)
                    {
                    fileOut<<"teleporter\n";
                    }
                if (pyr==1)
                    {
                    fileOut<<"pyramid\n";
                    }
                fileOut<<"name "<<name<<"\n";
                fileOut<<"\tposition "<<ldxPos<<" "<<ldyPos<<" "<<ldzPos<<"\n";

                if (rotString!="0")
                    {
                    rotDouble=atof(rot);
                    rotDouble=convertrot(rotDouble);
                    fileOut<<"\trotation "<<rotDouble<<"\n";
                    }

                if (tel==1)
                    {
                    fileOut<<"\tsize .125 "<<ySize<<" "<<ldzSize<<"\n";
                    fileOut<<"\tborder 1\n";
                    }
                else
                    fileOut<<"\tsize "<<xSize<<" "<<ySize<<" "<<ldzSize<<"\n";
                fileOut<<"end\n\n";
            }
        if (fileIn.eof())
            {
            cout << "\n*** At end of file. ***\n";
            goto end;
            }
        }

    end:
    fileIn.close();
    fileOut.close();
    cout << "Done.\n";
    return 0;
}

double convertrot(double in)
{
    double out;
    out=(2)*( acos(in) *180/pi );
    return out;
}

